﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Shapes;
using WpfAppCrossRayRay.MyCode;


//====================================================
// Описание работы классов и методов исходника на:
// www.interestprograms.ru
// Исходные коды программ и игр
// Автор исходных кодов Клочков Павел
//====================================================

namespace WpfAppCrossRayRay
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private readonly Ellipse crossPoint = new();


        public MainWindow()
        {
            InitializeComponent();


            // 

            // Точка пересечения
            crossPoint.RenderTransform = new TranslateTransform(-6, -6);
            crossPoint.Fill = Brushes.Green;
            crossPoint.StrokeThickness = 1;
            crossPoint.Width = crossPoint.Height = 12;
            crossPoint.Stroke = Brushes.White;

            canvas1.Children.Add(crossPoint);
        }

        private void Canvas_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            CorrectLines();
        }

        private void Canvas_MouseDown(object sender, MouseButtonEventArgs e)
        {

            // Синий луч

            if (Keyboard.IsKeyDown(Key.LeftShift) == true)
            {
                Canvas.SetLeft(ABControlDot1, e.GetPosition(canvas1).X);
                Canvas.SetTop(ABControlDot1, e.GetPosition(canvas1).Y);

                ABpX1.Text = Canvas.GetLeft(ABControlDot1).ToString();
                ABpY1.Text = Canvas.GetTop(ABControlDot1).ToString();
            }


            if (Keyboard.IsKeyDown(Key.RightShift) == true)
            {
                Canvas.SetLeft(ABControlDot2, e.GetPosition(canvas1).X);
                Canvas.SetTop(ABControlDot2, e.GetPosition(canvas1).Y);

                ABpX2.Text = Canvas.GetLeft(ABControlDot2).ToString();
                ABpY2.Text = Canvas.GetTop(ABControlDot2).ToString();
            }

            //


            // Красный луч

            if (Keyboard.IsKeyDown(Key.LeftCtrl) == true)
            {
                Canvas.SetLeft(CDControlDot1, e.GetPosition(canvas1).X);
                Canvas.SetTop(CDControlDot1, e.GetPosition(canvas1).Y);

                CDpX1.Text = Canvas.GetLeft(CDControlDot1).ToString();
                CDpY1.Text = Canvas.GetTop(CDControlDot1).ToString();
            }


            if (Keyboard.IsKeyDown(Key.RightCtrl) == true)
            {
                Canvas.SetLeft(CDControlDot2, e.GetPosition(canvas1).X);
                Canvas.SetTop(CDControlDot2, e.GetPosition(canvas1).Y);

                CDpX2.Text = Canvas.GetLeft(CDControlDot2).ToString();
                CDpY2.Text = Canvas.GetTop(CDControlDot2).ToString();
            }
        }


        private void CorrectLines()
        {

            // Синий луч
            double ABDotX1 = Canvas.GetLeft(ABControlDot1);
            double ABDotY1 = Canvas.GetTop(ABControlDot1);

            double ABDotX2 = Canvas.GetLeft(ABControlDot2);
            double ABDotY2 = Canvas.GetTop(ABControlDot2);

            // Красный луч
            double CDDotX1 = Canvas.GetLeft(CDControlDot1);
            double CDDotY1 = Canvas.GetTop(CDControlDot1);

            double CDDotX2 = Canvas.GetLeft(CDControlDot2);
            double CDDotY2 = Canvas.GetTop(CDControlDot2);



            // equtation
            Point p1 = new(ABDotX1, ABDotY1);
            Point p2 = new(ABDotX2, ABDotY2);

            Point m1 = new(CDDotX1, CDDotY1);
            Point m2 = new(CDDotX2, CDDotY2);


            Equtation(p1, p2, m1, m2);




            // Вычисляем точку пересечения лучей
            bool res = Intersections.SegmentSegment(p1, p2, m1, m2, out Point pCross, out Info info);

            crossInfo.Content = info.Message;
            
            if (res == true)
            {
                crossPoint.Visibility = Visibility.Visible;
                Canvas.SetLeft(crossPoint, pCross.X);
                Canvas.SetTop(crossPoint, pCross.Y);
                crossX.Content = "x= " + pCross.X;
                crossY.Content = "y= " + pCross.Y;
            }
            else
            {
                crossPoint.Visibility = Visibility.Hidden;
                crossX.Content = "x= -";
                crossY.Content = "y= -";
            }
            
            
        }

        private void CDpX1_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (this.IsInitialized == false) return;

            var tb = sender as TextBox;
            string number = tb.Text;

            if (double.TryParse(number, out double value) == false) return;


            if (tb == CDpX1) Canvas.SetLeft(CDControlDot1, value);

            if (tb == CDpY1) Canvas.SetTop(CDControlDot1, value);

            if (tb == CDpX2) Canvas.SetLeft(CDControlDot2, value);

            if (tb == CDpY2) Canvas.SetTop(CDControlDot2, value);

            if (tb == ABpX1) Canvas.SetLeft(ABControlDot1, value);

            if (tb == ABpY1) Canvas.SetTop(ABControlDot1, value);

            if (tb == ABpX2) Canvas.SetLeft(ABControlDot2, value);

            if (tb == ABpY2) Canvas.SetTop(ABControlDot2, value);


            // После изменения координат опорных точек прямых
            // корректируем линии.
            CorrectLines();

        }



        /// <summary>
        /// Вычисление уравнений описывающих лучи и корректировка длин линий лучей
        /// </summary>
        /// <param name="R1"></param>
        /// <param name="R2"></param>
        /// <param name="P1"></param>
        /// <param name="P2"></param>
        private void Equtation(Point R1, Point R2, Point P1, Point P2)
        {

            //equtation
            
             /*
             Отрезок уравнения
             
             x = x0 + vt
             y = y0 + wt

             где v = x1 - x0
                 w = y1 - y0
             */

            // Уравнение первого луча
            EquationRX.Text = "x = " + R1.X.ToString() + " + " + (R2.X - R1.X).ToString() + "t";
            EquationRY.Text = "y = " + R1.Y.ToString() + " + " + (R2.Y - R1.Y).ToString() + "t";


            // Уравнение второго луча
            EquationPX.Text = "x = " + P1.X.ToString() + " + " + (P2.X - P1.X).ToString() + "t";
            EquationPY.Text = "y = " + P1.Y.ToString() + " + " + (P2.Y - P1.Y).ToString() + "t";

           
            // ----- Синий отрезок -----
            rayAB.X1 = R1.X;
            rayAB.Y1 = R1.Y;
            rayAB.X2 = R2.X;
            rayAB.Y2 = R2.Y;

            // ----- /Синий отрезок -----

            

            // ----- Красный отрезок -----
            rayCD.X1 = P1.X;
            rayCD.Y1 = P1.Y;
            rayCD.X2 = P2.X;
            rayCD.Y2 = P2.Y;
            // ----- /Красный отрезок -----

        }

    }
}
